﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.3
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Private MainForm As Form
	Private Preview As Form
	Private LblTotal As B4XView
	Private LblTotalPreview As B4XView
End Sub


Sub Initialize_A4(textstring As String, ShowPrintDialog As Boolean)
	
	MainForm.Initialize("", 605,870)
	'    MainView.WindowWidth  = 605 'For A4 605x870
	'    MainView.WindowHeight = 870 'For A4 605x870
	MainForm.RootPane.LoadLayout("A4Size.bjl") '---->>> For A4 605x870 <<<----
	MainForm.Title = SharedCode.JopView
	MainForm.Icon = fx.LoadImage(File.DirAssets, "Untitled - 4.png")
	MainForm.WindowHeight = fx.PrimaryScreen.MaxY - fx.PrimaryScreen.MinY
	
	
	Preview.Initialize("", 605,870)
	Preview.RootPane.LoadLayout("A4SizePreview") '---->>> For A4 605x870 <<<----
	Preview.Title = SharedCode.JopView
	Preview.Icon = fx.LoadImage(File.DirAssets, "Untitled - 4.png")
	Preview.WindowHeight = fx.PrimaryScreen.MaxY - fx.PrimaryScreen.MinY
	
	CSSUtils.SetStyleProperty(LblTotal,"-fx-padding","0,10,10,0")
	CSSUtils.SetStyleProperty(LblTotalPreview,"-fx-padding","0,10,10,0")
    
	LblTotal.Text = textstring
	LblTotalPreview.Text = textstring
	
	Private PL As PageLayout
	Dim PJ As PrinterJob
	If ShowPrintDialog Then
		PJ = PrinterJob_Static.CreatePrinterJob
		
		If PJ.ShowPageSetupDialog(Null) = False Then
			PJ.CancelJob
			Return
		End If
		If PJ.ShowPrintDialog(Null) = False Then
			PJ.CancelJob
			Return
		End If
		
		PL = PJ.GetJobSettings.GetPageLayout
	Else
		Dim PA As Paper
		PA.Initialize()
		PA = Paper_static.A4
        
		Private PR As Printer
		PR.Initialize()
		PR = Printer_Static.GetDefaultPrinter
		
		PJ = PrinterJob_Static.CreatePrinterJob2(PR)
		PL = PR.CreatePageLayout2(PA, PageOrientation_Static.PORTRAIT, "DEFAULT") '"HARDWARE_MINIMUM")
	End If
	
	If LblTotal.Text <> "" Then
		'Set the label sizes for the preview
		LblTotalPreview.Left = PL.GetLeftMargin
		LblTotalPreview.Top = PL.GetTopMargin
		LblTotalPreview.Width = PL.GetPrintableWidth
		LblTotalPreview.Height = PL.GetPrintableHeight

		'Set the label sizes for the output, the label must be at left=0 top = 0 as margins will be applied to the printer.
		LblTotal.Width = PL.GetPrintableWidth
		LblTotal.TextSize = 12
		LblTotalPreview.TextSize = 12
		
		
	End If
	
	
	Preview.Show
	
	If LblTotal.Text <> "" Then
		
        
		
		Dim JS As JobSettings = PJ.GetJobSettings
		JS.SetJobName("New 1")
		PJ.PrintPage2(PL, LblTotal)
		If PJ.EndJob Then
			Dim myClipBoard As JavaObject
			myClipBoard.InitializeStatic("javafx.scene.input.Clipboard")
			myClipBoard.RunMethodJO("getSystemClipboard",Null).RunMethod("clear",Null)
			Main.xui.Msgbox2Async("Successfully spooleded to the printer queue.", "Printer Job","OK","","",Null)
		End If
	End If
End Sub





Sub Initialize_A4_Old(textstring As String)
	MainForm.Initialize("", 0,0)
	MainForm.WindowWidth  = 605 'For A4 605x870
	MainForm.WindowHeight = 870 'For A4 605x870
	MainForm.RootPane.LoadLayout("A4Size")
	
	MainForm.Title = SharedCode.JopView
	MainForm.Icon = fx.LoadImage(File.DirAssets, "Untitled - 4.png")
	MainForm.WindowHeight = fx.PrimaryScreen.MaxY - fx.PrimaryScreen.MinY
	
	LblTotal.Text = textstring
	MainForm.ShowAndWait
	SharedCode.PrintToJob(MainForm, True, "", True, LblTotal) '"Brother DCP-L2510D series" is my printer name
End Sub

Sub Initialize_Letter(textstring As String)
	MainForm.Initialize("", 0,0)
	MainForm.WindowWidth  = 620 'For Letter 620x775
	MainForm.WindowHeight = 775 'For Letter 620x775
	MainForm.RootPane.LoadLayout("LetterSize")
	
	LblTotal.Text = textstring
	SharedCode.PrintToJob(MainForm, False, "", True,LblTotal) '"Brother DCP-L2510D series" is my printer name
End Sub
